---
title: mask
slug: Web/CSS/mask
tags:
  - CSS
  - CSS Masking
  - CSS Property
  - Layout
  - Reference
  - SVG
  - Web
  - 'recipe:css-shorthand-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>mask</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand property</a> hides an element (partially or fully) by masking or clipping the image at specific points.</p>

<div class="note">
<p>As well as the properties listed below, the <code>mask</code> shorthand also resets {{cssxref("mask-border")}} to its initial value. It is therefore recommended to use the <code>mask</code> shorthand rather than other shorthands or the individual properties to override any mask settings earlier in the cascade. This will ensure that <code>mask-border</code> has also been reset to allow the new styles to take effect.</p>
</div>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
	<li><a href="/en-US/docs/Web/CSS/mask-clip"><code>mask-clip</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-composite"><code>mask-composite</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-image"><code>mask-image</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-mode"><code>mask-mode</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-origin"><code>mask-origin</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-position"><code>mask-position</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-repeat"><code>mask-repeat</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/mask-size"><code>mask-size</code></a></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-number notranslate">/* Keyword values */
mask: none;

/* Image values */
mask: url(mask.png);                       /* Pixel image used as mask */
mask: url(masks.svg#star);                 /* Element within SVG graphic used as mask */

/* Combined values */
mask: url(masks.svg#star) luminance;       /* Element within SVG graphic used as luminance mask */
mask: url(masks.svg#star) 40px 20px;       /* Element within SVG graphic used as mask positioned 40px from the top and 20px from the left */
mask: url(masks.svg#star) 0 0/50px 50px;   /* Element within SVG graphic used as mask with a width and height of 50px */
mask: url(masks.svg#star) repeat-x;        /* Element within SVG graphic used as horizontally repeated mask */
mask: url(masks.svg#star) stroke-box;      /* Element within SVG graphic used as mask extending to the box enclosed by the stroke */
mask: url(masks.svg#star) exclude;         /* Element within SVG graphic used as mask and combined with background using non-overlapping parts */

/* Global values */
mask: inherit;
mask: initial;
mask: unset;

/* Multiple masks */
mask: url(masks.svg#star) left / 16px repeat-y,    /* Element within SVG graphic is used as a mask on the left-hand side with a width of 16px */
      url(masks.svg#circle) right / 16px repeat-y; /* Element within SVG graphic is used as a mask on the right-hand side with a width of 16px */
</pre>

<h3 id="Values">Values</h3>

<dl>
	<dt><code>&lt;mask-reference&gt;</code></dt>
	<dd>Sets the mask image source. See {{cssxref("mask-image")}}.</dd>
	<dt><code>&lt;masking-mode&gt;</code></dt>
	<dd>Sets the masking mode of the mask image. See {{cssxref("mask-mode")}}.</dd>
	<dt><code>&lt;position&gt;</code></dt>
	<dd>Sets the position of the mask image. See {{cssxref("mask-position")}}.</dd>
	<dt><code>&lt;bg-size&gt;</code></dt>
	<dd>Sets the size of the mask image. See {{cssxref("mask-size")}}.</dd>
	<dt><code>&lt;repeat-style&gt;</code></dt>
	<dd>Sets the repetition of the mask image. See {{cssxref("mask-repeat")}}.</dd>
	<dt><code>&lt;geometry-box&gt;</code></dt>
	<dd>If only one <code>&lt;geometry-box&gt;</code> value is given, it sets both {{cssxref("mask-origin")}} and {{cssxref("mask-clip")}}. If two <code>&lt;geometry-box&gt;</code> values are present, then the first sets {{cssxref("mask-origin")}} and the second sets {{cssxref("mask-clip")}}.</dd>
	<dt><code>&lt;geometry-box&gt; | no-clip</code></dt>
	<dd>Sets the area that is affected by the mask image. See {{cssxref("mask-clip")}}.</dd>
	<dt><code>&lt;compositing-operator&gt;</code></dt>
	<dd>Sets the compositing operation used on the current mask layer. See {{cssxref("mask-composite")}}.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Masking_an_image">Masking an image</h3>

<pre class="brush: css notranslate">.target {
  mask: url(#c1) luminance;
}

.anothertarget {
  mask: url(resources.svg#c1) 50px 30px/10px 10px repeat-x exclude;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName("CSS Masks", "#the-mask", 'mask')}}</td>
			<td>{{Spec2("CSS Masks")}}</td>
			<td>Extends its usage to HTML elements.<br>
			Extends its syntax by making it a shorthand for the new <code>mask-*</code> properties defined in that specification.</td>
		</tr>
		<tr>
			<td>{{SpecName('SVG1.1', 'masking.html#MaskProperty', 'mask')}}</td>
			<td>{{Spec2('SVG1.1')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("css.properties.mask")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{Cssxref("clip-path")}}, {{Cssxref("filter")}}</li>
	<li><a href="https://hacks.mozilla.org/2017/06/css-shapes-clipping-and-masking/">CSS Shapes, clipping and masking – and how to use them</a></li>
	<li><a href="/en-US/docs/Applying_SVG_effects_to_HTML_content">Applying SVG effects to HTML content</a></li>
	<li><a href="/en-US/docs/SVG">SVG</a></li>
</ul>
